//
//  BrushTool.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Wed Jan 29 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package paint;
import java.awt.*;
import treehouse.*;

public class BrushTool extends THSGeneralTool {

    protected int lastmx, lastmy;
    protected PaintBrush curbsh;

    public BrushTool() {
        super();
        curbsh = PaintBrush.makeSquareBrush(8);
    }

    public String getIconImage() {
        return "painticon-1_brush.gif";
    }

    public String getCursorImage() {
        return "";
    }

    public String getString() {
        return "Brush";
    }

    public boolean mouseDown(int mx, int my, THSCanvas c) {
        lastmx = mx;
        lastmy = my;
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
        return true;
    }

    public boolean mouseDrag(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
        lastmx = mx;
        lastmy = my;
        return true;
    }

    public boolean mouseMove(int mx, int my, THSCanvas c) {
        return false;
    }

    public boolean mouseUp(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        Simple.line(gi,curbsh,lastmx,lastmy,mx,my);
        return true;
    }

    public boolean keyPressed(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyUp(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyDown(Event ke, int k, THSCanvas c) { return false; }
}
