//
//  FilledOvalTool.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Sat Feb 01 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package paint;
import java.awt.*;
import treehouse.*;

public class FilledOvalTool extends THSGeneralTool {

    protected int startmx;
    protected int startmy;
    protected PaintBrush curbsh;

    public FilledOvalTool() {
        super();
        curbsh = PaintBrush.makeSquareBrush(2);
    }

    /**
        * What happens when one of the following mouse interactions occur.
     *
     * Note that the (mx, my) coordinate should be referring to the model in which the top left corner of the
     * canvas is (0,0) and the limits of the region are the width and height of the canvas.
     */
    public boolean mouseDown(int mx, int my, THSCanvas c) {
        startmx = mx;
        startmy = my;
        ((PaintCanvas) c).push();
        Shapes.ovalfilladjusted((PaintCanvas) c, curbsh, startmx, startmy, mx, my);
        return true;
    }

    public boolean mouseDrag(int mx, int my, THSCanvas c) {
        ((PaintCanvas) c).recover();
        Shapes.ovalfilladjusted((PaintCanvas) c, curbsh, startmx, startmy, mx, my);
        return true;
    }

    public boolean mouseMove(int mx, int my, THSCanvas c) {
        return false;
    }
    
    public boolean mouseUp(int mx, int my, THSCanvas c) {
        ((PaintCanvas) c).recover();
        Shapes.ovalfilladjusted((PaintCanvas) c, curbsh, startmx, startmy, mx, my);
        ((PaintCanvas) c).pop();
        return true;
    }

    /**
        * What happens when one of the following key interactions occur
     */
    public boolean keyPressed(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyUp(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyDown(Event ke, int k, THSCanvas c) { return false; }

    public String getIconImage() {
        return "painticon-1_fcircle.gif";
    }

    public String getCursorImage() {
        return "";
    }

    public String getString() {
        return "Filled Oval";
    }


}

