//
//  LineTool.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Wed Jan 29 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package paint;
import java.awt.*;
import treehouse.*;

public class LineTool extends THSGeneralTool {

    protected int startmx;
    protected int startmy;
    protected PaintBrush curbsh;
    
    public LineTool() {
        super();
        curbsh = PaintBrush.makeSquareBrush(2);
    }
    
    public String getIconImage() {
        return "painticon-1_line.gif";
    }

    public String getCursorImage() {
        return "";
    }

    public String getString() {
        return "Line";
    }

    public boolean mouseDown(int mx, int my, THSCanvas c) {
        startmx = mx;
        startmy = my;
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        ((PaintCanvas) c).push();
        Simple.line(gi,curbsh,startmx,startmy,mx,my);
        return true;
    }

    public boolean mouseMove(int mx, int my, THSCanvas c) {
        return false;
    }

    public boolean mouseUp(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        ((PaintCanvas) c).recover();
        Simple.line(gi,curbsh,startmx,startmy,mx,my);
        ((PaintCanvas) c).pop();
        return true;
    }

    public boolean mouseDrag(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        ((PaintCanvas) c).recover();
        Simple.line(gi,curbsh,startmx,startmy,mx,my);
        return true;
    }

    public boolean keyPressed(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyUp(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyDown(Event ke, int k, THSCanvas c) { return false; }
}
