//
//  MessagePanel.java
//  Treehousestudio
//
//  Created by mplanck on Fri Aug 16 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

package paint;
import java.awt.*;
import java.util.*;

import treehouse.THSPanel;

public class MessagePanel extends THSPanel {

    private Color color;
    private String message;
    private Font font;

    public static final int ERROR = 0;
    public static final int SAVE = 1;
    public static final int LOAD = 2;
    public static final int UPDATE = 3;
    public static final int I_ERROR = 4;

    public MessagePanel(int _x, int _y, int _w, int _h)
    {
        super("Message Panel",_x,_y,_w,_h);
        font = new Font("Helvetica", Font.BOLD, 12);
        message = "Welcome to Treehouse Paint";
    }

    public boolean mouseDown(Event ev, int mx, int my) {
        return false;
    }

    public boolean mouseDrag(Event ev, int mx, int my) {
        return false;
    }

    public boolean mouseUp(Event ev, int mx, int my) {
        return false;
    }

    public boolean keyDown(Event ev, int k) {
        return false;
    }

    public void paint(Graphics g)
    {
        g.setColor(color);
        g.drawRect(cx,cy,cw,ch);
        g.setFont(font);
        FontMetrics fm = g.getFontMetrics();
        g.drawString(message, cx+4, cy+fm.getHeight());
    }

    /**
     * This message method doesn't really care who's sending it.  It only takes information from the object data.
     * Object data that is sent should have a two elements in it, the first element being an Integer object corresponding
     * to one of the static final variables at the top of this class.  The second element should be a String describing
     * the message to be displayed.  If the odat is less than 2 elements and the first and second element are not of
     * proper class, the message is updated to display an Internal Error.
     *
     * An example of a possible object to send would be: MessagePanel.ERROR + "This is an error"
     */
    public void message(String fromWho, Object odat) {
        try {
            String str = (String) odat;
            int type = (new Integer(str.substring(0, 1))).intValue();
            String mess = str.substring(1, str.length());

            // This crops the message
            if (mess.length() > 100) { // This should be made dynamic to the panel width
                mess = mess.substring(0,100);
            }
            switch (type) {
                case ERROR:
                    color = Color.red;
                    message = mess;
                    break;
                case SAVE:
                    color = Color.blue;
                    message = mess;
                    break;
                case LOAD:
                    color = Color.blue;
                    message = mess;
                    break;
                case UPDATE:
                    color = Color.blue;
                    message = mess;
                    break;
                default:
                    throw new Exception("The type of error reported is not a proper type");
            }
        } catch (Exception e) {
            color = Color.red;
            message = "Internal Error: " + e.getMessage();
        }
    }
}
