//
//  menuitem.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Tue Jan 07 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package paint;
import java.awt.*;
import java.applet.*;
import treehouse.*;

/**
 * This class is an extension of THSMenuItems and it implements all menu items for the paint applet.
 */

public class PaintMenuItems extends THSMenuItems {

    /***********************************************************************************
    ************************************************************************************
    ************************************************************************************
    **
    ** Add menu item stuff after this point.  Refer to the HOW TO guide in the THSMenuItems class
    ** for info on adding a menu item.
    **
    ************************************************************************************
    ************************************************************************************
    ************************************************************************************/

    // These static final variables are used to reference the type of menu item to be instantiated
    // when the makeMenuItem() method is called.
    public final static int COPY = 1;
    public final static int CUT = 2;
    public final static int PASTE = 3;
    public final static int UNDO = 5;
    public final static int SHOWCLIPBOARD = 6;
    public final static int SAVE = 7;
    public final static int OPEN = 8;

    public final static int TEST = 9;
    /**
     * This method produces a menu item given a specific name.  It also takes in
     * the arguments that a menu item might use.  If the name specified is not a valid
     * menu item, null is returned.
     */
    public static THSGeneralMenuItem makeMenuItem(int name, THSCanvas mainCanvas, Applet app) {
        switch (name) {
            case COPY:
                return new CopyMenuItem();
            case CUT:
                return new CutMenuItem();
            case PASTE:
                return new PasteMenuItem();
            case UNDO:
                return new UndoMenuItem(mainCanvas);
            case SHOWCLIPBOARD:
                return new ShowClipboardMenuItem();
            case SAVE:
                return new SaveMenuItem(mainCanvas);
            case OPEN:
                return new OpenMenuItem(mainCanvas);
            case TEST:
                return new TestMenuItem(mainCanvas);
            default:
                return THSMenuItems.makeMenuItem(name, mainCanvas, app);
        }
    }
    
}

/***********************************************************************************
************************************************************************************
************************************************************************************
**
** All of the following menu items are original and should not be modified unless you
** want to mess with core functionality.
**
************************************************************************************
************************************************************************************
************************************************************************************/

 // All the menu items right now are not completed (THIS NEEDS TO CHANGE)


class OpenMenuItem extends THSGeneralMenuItem{

    THSCanvas mainCanvas;
    
    public OpenMenuItem(THSCanvas c) {
        super("Open");
        mainCanvas = c;
    }

    public void actuate() {
        mainCanvas.doOpen(3);
        return;
    }

}

class SaveMenuItem extends THSGeneralMenuItem {

    THSCanvas mainCanvas;
    Graphics g;
    Applet app;

    public SaveMenuItem(THSCanvas c) {
        super("Save");
        mainCanvas = c;
    }

    public void actuate() {
        System.out.println("Should be saving");
        mainCanvas.doSave();
    }
}

class CopyMenuItem extends THSGeneralMenuItem {

    public CopyMenuItem() {
        super("Copy");
    }

    public void actuate() {
        // do nothing
        return;
    }

}

class CutMenuItem extends THSGeneralMenuItem {

    public CutMenuItem() {
        super("Cut");
    }

    public void actuate() {
        // do nothing
        return;
    }

}


class PasteMenuItem extends THSGeneralMenuItem {

    public PasteMenuItem() {
        super("Paste");
    }

    public void actuate() {
        // do nothing
        return;
    }

}

class ShowClipboardMenuItem extends THSGeneralMenuItem {

    public ShowClipboardMenuItem() {
        super("Show Clipboard");
    }

    public void actuate() {
        // do nothing
        return;
    }

}

class UndoMenuItem extends THSGeneralMenuItem {

    THSCanvas mainCanvas;

    public UndoMenuItem(THSCanvas THSPanel) {
        super("Undo");

        mainCanvas = THSPanel;
    }

    public void actuate() {
        System.out.println("Undo");
        mainCanvas.doUndo();
    }

}

class TestMenuItem extends THSGeneralMenuItem {

    THSCanvas mainCanvas;
    
    public TestMenuItem(THSCanvas c) {
        super("Test Saving");
        mainCanvas = c;
    }
    
    public void actuate() {
        ((PaintCanvas) mainCanvas).doTest();
    }
    
}