//
//  Simple.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Wed Jan 22 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package paint;
import java.awt.*;
import java.applet.*;
import java.util.Random;

/**
 * This is a helpful drawing class that provides functionality for drawing a dot, a line, and even
 * doing a flood fill.
 */

public class Simple {

    public static void dot(Graphics g, int x, int y) {
        g.drawLine(x,y,x,y);
    }

    public static void line(Graphics g, PaintBrush curbsh, int ox1, int oy1, int ox2, int oy2) {
        int dx, dy, incrE, incrNE, d, x, y, twoV, sdx=0, sdy=0;
        float invDenom, twoDX, scratch, slope;
        int x1, x2, y1, y2, incy=0, incx=0, which;
        boolean backwards = false, slopeDown = false;
        /* first do horizontal line */
        if(ox1==ox2) {
            x = ox1;
            if(oy1 < oy2) { y1 = oy1; y2 = oy2; }
            else { y1 = oy2; y2 = oy1; }
            for(y=y1;y<=y2;y++) {
                curbsh.paint(g,x, y);
            }
            return;
        }
        slope = (float)(oy2 - oy1)/(float)(ox2 - ox1);
        /* check for which 1, 0 <= slope <= 1 */
        if(slope >= 0 && slope <= 1) which = 1;
        else if(slope > 1) which = 2;
        else if(slope < -1) which = 3;
        else which=4;
        if(((which==1 || which==2 ||which==4) && ox1 > ox2) || ((which==3) && ox1 < ox2)) {
            x1 = ox2;
            x2 = ox1;
            y1 = oy2;
            y2 = oy1;
        }
        else {
            x1 = ox1;
            y1 = oy1;
            x2 = ox2;
            y2 = oy2;
        }
        dx = x2 - x1;
        dy = y2 - y1;
        if(which==1) {
            sdx = dx;
            d = 2 * dy - dx;
            incy = 1;
            incrE = 2*dy;
            incrNE = 2*(dy-dx);
        }
        else if(which==2) {
            sdy = dy;
            d = 2 * dx - dy;
            incx = 1;
            incrE = 2*dx;
            incrNE = 2*(dx-dy);
        }
        else if(which==3) {
            sdy = -dy;
            d = -2 * dx - dy;
            incx = -1;
            incrE = -2*dx;
            incrNE = -2*(dx+dy);
        }
        else /*if(which == 4)*/ {
            sdx = -dx;
            d = -2 * dy - dx;
            incy = -1;
            incrE = -2*dy;
            incrNE = -2*(dy+dx);
        }
        if(which==1 || which==4) {
            twoV = 0;
            invDenom = 1.0f / (2.0f * (float)Math.sqrt(dx*dx + dy*dy));
            twoDX = 2 * sdx * invDenom;
            x = x1;
            y = y1;
            curbsh.paint(g,x, y);
            while(x < x2) {
                if(d<0) {
                    twoV = d + dx;
                    d += incrE;
                    ++x;
                }
                else {
                    twoV = d - dx;
                    d += incrNE;
                    ++x;
                    y+=incy;
                }
                scratch = twoV * invDenom;
                curbsh.paint(g,x, y);
            }
        }
        else {
            twoV = 0;
            invDenom = 1.0f / (2.0f * (float)Math.sqrt(dx*dx + dy*dy));
            twoDX = 2 * sdy * invDenom;
            x = x1;
            y = y1;
            curbsh.paint(g,x, y);
            while(y < y2) {
                if(d<0) {
                    twoV = d + dy;
                    d += incrE;
                    ++y;
                }
                else {
                    twoV = d - dy;
                    d += incrNE;
                    ++y;
                    x+=incx;
                }
                scratch = twoV * invDenom;
                curbsh.paint(g,x, y);
            }
        }
    }

    private static Random ran = new Random();
    public static void dospray(Graphics g, int x, int y)
    {
        int i;
        for(i=0;i<50;i++) {
            Simple.dot(g,x+(int)(ran.nextGaussian()*8),y+(int)(ran.nextGaussian()*8));
        }
    }

    static int []pv;
    static int pw, ph;
    static int ocol, ncol;

    public static void pcol(int r)
    {
        System.out.println("rgb: "+((r>>16)&0xff) + "/"+ ((r>>8)&0xff) +"/"+(r&0xff) +"/"+((r>>24)&0xff));
    }

    public static void floodfill(PaintCanvas pc, int x, int y)
    {
        int r, g, b;
        Image im = pc.getImage();
        Applet app = pc.getApp();
        Graphics gi = im.getGraphics();
        int cw = pc.getCw();
        int ch = pc.getCh();
        g = pc.getFGColor().getGreen();
        r = pc.getFGColor().getRed();
        b = pc.getFGColor().getBlue();

        PaintImageRasterizer imdat = new PaintImageRasterizer(cw,ch);
        imdat.convertToBytes(im);
        pv = imdat.graster; ph = ch; pw = cw;

        ocol = pixelread(x,y);

        //   System.out.println("r: "+r+" g: "+g+" b: "+b);

        ncol = ((r<<16)|(g<<8)|b);

        //     System.out.println("olcol/ncol: "+ocol+"/"+ncol);
        //    pcol(ocol); pcol(ncol);
        ocol =(0xffffff&ocol);

        //      dofill(x,y);
        fill(cw, ch, x,y,ncol);
        // now put buffer back
        gi.drawImage(imdat.rasterImage(app),0,0,app);
    }

    public static void dofill(int x, int y)
    {
        //     System.out.println("fill "+x+"/"+y);
        if ((x<0)||(x>=pw)) return;
        if ((y<0)||(y>=ph)) return;

        if ((0xffffff&pixelread(x,y))==ocol) {
            //           System.out.println("pxwr: "+x+"/"+y);
            pixelwrite(x,y,ncol);
            dofill(x+1,y); dofill(x-1,y); dofill(x,y+1); dofill(x,y-1);
        }
    }

    public static int pixelread(int x, int y)
    {
        return 0xffffff&pv[x+y*pw];
    }
    public static void pixelwrite(int x, int y, int nv)
    {
        pv[x+y*pw] = nv;
    }

    public static int setPixel(int x, int y)
    {
        return pv[x+y*pw];
    }
    public static void getPixel(int x, int y, int nv)
    {
        pv[x+y*pw] = nv;
    }

    final static int MAX =10000;		/* max depth of stack */
    static int spc=0;

    static Segment stack[]=null;
    static int wy0, wy1, wx0,wx1;

    public static void PUSH(int Y, int XL, int XR, int DY)	/* push new segment on stack */
    {
        if (spc<MAX && Y+(DY)>=wy0 && Y+(DY)<=wy1)
        {stack[spc].y = Y; stack[spc].xl = XL; stack[spc].xr = XR; stack[spc].dy = DY; spc++;}
    }


    public static void fill(int cw, int ch, int x, int y, int nv)
    {
        wx0 = 0; wx1 = cw-1; wy0 = 0; wy1 = ch-1;

        int l=0, x1, x2, dy;
        int ov;	/* old pixel value */

        if (stack==null) {
            stack = new Segment[MAX];
            int i;
            for(i=0;i<MAX;i++) stack[i] = new Segment();
        }
        spc = 0;

        ov = pixelread(x, y);		/* read pv at seed point */
        if (ov==nv || x<wx0 || x>wx1 || y<wy0 || y>wy1) return;
        PUSH(y, x, x, 1);			/* needed in some cases */
        PUSH(y+1, x, x, -1);		/* seed segment (popped 1st) */

        while (spc>0) {
            /* pop segment off stack and fill a neighboring scan line */

            //POP(y, x1, x2, dy);

            spc--;
            dy = stack[spc].dy;
            y = stack[spc].y+dy;
            x1 = stack[spc].xl;
            x2 = stack[spc].xr;

            /*
             * segment of scan line y-dy for x1<=x<=x2 was previously filled,
             * now explore adjacent pixels in scan line y
             */
            for (x=x1; x>=wx0 && pixelread(x, y)==ov; x--)
                pixelwrite(x, y, nv);

            if (x>=x1) {
                boolean skipp = true;
                do {
                    if (!skipp) {
                        for (; x<=wx1 && pixelread(x, y)==ov; x++) pixelwrite(x, y, nv);
                        PUSH(y, l, x-1, dy);
                        if (x>x2+1) PUSH(y, x2+1, x-1, -dy);	/* leak on right? */
                    }
                    for (x++; x<=x2 && pixelread(x, y)!=ov; x++); skipp = false;
                    l = x;
                } while (x<=x2);
                continue;
            }

            l = x+1;
            if (l<x1) PUSH(y, l, x1-1, -dy);		/* leak on left? */
            x = x1+1;
            do {
                for (; x<=wx1 && pixelread(x, y)==ov; x++)
                    pixelwrite(x, y, nv);
                PUSH(y, l, x-1, dy);
                if (x>x2+1) PUSH(y, x2+1, x-1, -dy);	/* leak on right? */
                for (x++; x<=x2 && pixelread(x, y)!=ov; x++);
                l = x;
            } while (x<=x2);
        }

    }

    /*
     public void fillFast(int x, int y, int fill)
     {
         if ((x < 0) || (x >= pw)) return;
         if ((y < 0) || (y >= ph)) return;
         int old = raster.getPixel(x, y);
         if (old == fill) return;
         raster.setPixel(fill, x, y);
         fillEast(x+1, y, fill, old);
         fillSouth(x, y+1, fill, old);
         fillWest(x-1, y, fill, old);
         fillNorth(x, y-1, fill, old);
     }

     private void fillEast(int x, int y, int fill, int old)
     {
         if (x >= pw) return;
         if (raster.getPixel(x, y) == old) {
             raster.setPixel(fill, x, y);
             fillEast(x+1, y, fill, old);
             fillSouth(x, y+1, fill, old);
             fillNorth(x, y-1, fill, old);
         }
     }

     private void fillSouth(int x, int y, int fill, int old)
     {
         if (y >= ph) return;
         if (raster.getPixel(x, y) == old) {
             raster.setPixel(fill, x, y);
             fillEast(x+1, y, fill, old);
             fillSouth(x, y+1, fill, old);
             fillWest(x-1, y, fill, old);
         }
     }

     private void fillWest(int x, int y, int fill, int old)
     {
         if (x < 0) return;
         if (raster.getPixel(x, y) == old) {
             raster.setPixel(fill, x, y);
             fillSouth(x, y+1, fill, old);
             fillWest(x-1, y, fill, old);
             fillNorth(x, y-1, fill, old);
         }
     }

     private void fillNorth(int x, int y, int fill, int old)
     {
         if (y < 0) return;
         if (raster.getPixel(x, y) == old) {
             raster.setPixel(fill, x, y);
             fillEast(x+1, y, fill, old);
             fillWest(x-1, y, fill, old);
             fillNorth(x, y-1, fill, old);
         }
     }   */
    
}

class Segment
{
    public int y,xl,xr,dy;
    public Segment() {}
}
