//
//  TypeTool.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Thu Jan 23 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package paint;
import java.awt.*;
import java.util.*;

import treehouse.*;

/**
* This tool provides the functionality for typing text
 */

public class TypeTool extends THSGeneralTool {

    Font keyfont;
    int keysz = 18; // font size
    int keyld = 24; // leading
    int keyx=-1, keyy=-1;
    String keystr="";

    public TypeTool() {
        super();
        keyfont = new Font("Helvetica",Font.BOLD, keysz);
        keystr=""; keyx = -1; keyy = -1;
    }

    public boolean mouseDown(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.fillRect(mx,my,3,3);
        keyx = mx; keyy = my;
        keystr=""; // reset
        return true;
    }

    public boolean mouseMove(int mx, int my, THSCanvas c) { return false; }
    public boolean mouseUp(int mx, int my, THSCanvas c) { return false; }
    public boolean mouseDrag(int mx, int my, THSCanvas c) { return false; }

    public boolean keyPressed(Event ke, int k, THSCanvas c) {
        return false;
    }

    public boolean keyUp(Event ke, int k, THSCanvas c) {
        return false;
    }

    public boolean keyDown(Event ke, int k, THSCanvas c) {
        if (k == 8) { // backup
            int l = keystr.length();
            if (l>0)
                keystr = keystr.substring(0,l-1);
        } else {
            keystr+=(char)k;
        }
        drawkeystr(c, 0, 0, false);

        return true;
    }

    public String getIconImage() {
        return "painticon-1_type.gif";
    }

    public String getCursorImage() {
        return "";
    }

    public String getString() {
        return "Type";
    }

    public void drawkeystr(THSCanvas c, int ox, int oy, boolean tempp) {

        Graphics g = ((PaintCanvas) c).getGraphics();
        // not java 1.1!        ((Graphics2D) g).setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);

        StringTokenizer st = new StringTokenizer(keystr,"\n");
        int x, y;
        int len=0;
        String s;
        int lc=0;
        if (keyx == keyy && keyx == -1) return;
        g.setFont(keyfont);
        x = keyx+ox; y = keyy+oy;
        g.setColor(((PaintCanvas) c).getFGColor());
        while(st.hasMoreTokens()) {
            g.drawString(s=st.nextToken(),x,y);
            len = g.getFontMetrics().stringWidth(s);
            y+=keyld; lc++;
        }
        if (lc>0)
            y-=keyld;
        if (tempp) {
            g.fillRect(x+len+2,y-2,3,3);
        }
    }

}
