package treehouse;
//
//  THSCanvas.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Wed Jan 29 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.awt.*;

/**
 * HOW TO MAKE YOUR OWN CANVAS
 *
 * <UNDER CONSTRUCTION>
 */

public abstract class THSCanvas extends THSPanel {
    protected THSGeneralTool selectedTool;

    public THSCanvas(String _s, int _x, int _y, int _w, int _h) {
        super( _s, _x, _y, _w, _h);
    }

    public void message(String fromWho, Object odat) {
        if (fromWho.equals("Icon Panel")) {
                // before change mode
                /*if ((selectedTool != null) && (selectedTool.getString() == "Type")) {
                    selectedTool.textFreeze(gi);
                }*/
                selectedTool = (THSGeneralTool) odat;
                return;
        }
        System.err.println("An improper message was sent to " + this + " from " + fromWho);
    }  	

    /**
     * Should be overwritten by an implementing class. Undos the last operation by the tool.
     */
    
    public abstract void doUndo();
    /**
     * Should be overwritten by an implementing class. Saves the current state of the canvas for the doUndo method
     */
    public abstract void cacheUndo();
    
    /**
     * Should be overwritten by an implementing class.  Saves the canvas.
     */
    public abstract void doSave();

    /**
     * Should be overwritten by an implementing class. Opens a saved canvas.
     */
    public abstract void doOpen(int id);

    /**
     * Should be overwritten by an implementing class.  Draws the canvas.
     */
    public abstract void paint(Graphics g);

    /**
     * If the tool used does not draw in realtime, then call push() to save the state of the graphics before the tool
     * is begun (mouse pressed down).  This saves the graphics that are being drawn over so that, for example,
     * drawing a line doesn't result in messiness (the line is drawn every time the mouse is moved).
     */
    public boolean mouseDown(Event ev, int mx, int my) {
        // reset the mouse coordinates for this THSPanel
        mx-=cx; my-=cy;
        System.out.println(mx + " " + my);
        cacheUndo();
        selectedTool.mouseDown(mx, my, this);
        return true;
    }

    /**
     * For this method, if gi.drawImage(imstk,0,0,app) is called before anything is drawn to the graphic, the state
     * of the canvas before the tool was begun (mouse was clicked) is drawn before the resulting drag action is
     * drawn on top of it.  For example, when drawing a line, if this line is not used, the line would draw
     * to the actual canvas every time the mouse is dragged, resulting in an undesirable messiness.
     */
    public boolean mouseDrag(Event ev, int mx, int my) {
        mx-=cx; my-=cy;
        selectedTool.mouseDrag(mx, my, this);
        return true;
    }

    /**
     * Does anything happen when the mouse is moved?
     */
    public boolean mouseMove(Event ev, int mx, int my) {
        mx-=cx;my-=cy;
        selectedTool.mouseMove(mx, my, this);
        return true;
    }

    /**
     * Does anything happen when the mouse is released?
     */
    public boolean mouseUp(Event ev, int mx, int my) {
        mx-=cx; my-=cy;
        selectedTool.mouseUp(mx, my, this);
        return true;
    }

    public boolean keyDown(Event ev, int k)
    {
        return selectedTool.keyDown(ev, k, this);
    }

    public boolean keyPressed(Event ev, int k)
    {
        return selectedTool.keyPressed(ev, k, this);
    }

    public boolean keyUp(Event ev, int k)
    {
        return selectedTool.keyUp(ev, k, this);
    }
}