//
//  THSGeneralTool.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Wed Jan 29 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package treehouse;
import java.awt.*;
import java.awt.event.*;

public abstract class THSGeneralTool {

    public THSGeneralTool() {}
    
    /**
     * What happens when one of the following mouse interactions occur.
     *
     * Note that the (mx, my) coordinate should be referring to the model in which the top left corner of the
     * canvas is (0,0) and the limits of the region are the width and height of the canvas.
     */
    public abstract boolean mouseDown(int mx, int my, THSCanvas c);

    public abstract boolean mouseMove(int mx, int my, THSCanvas c);

    public abstract boolean mouseUp(int mx, int my, THSCanvas c);

    public abstract boolean mouseDrag(int mx, int my, THSCanvas c);

    /**
     * What happens when one of the following key interactions occur
     */
    public abstract boolean keyPressed(Event ke, int k, THSCanvas c);

    public abstract boolean keyUp(Event ke, int k, THSCanvas c);

    public abstract boolean keyDown(Event ke, int k, THSCanvas c);

    /**
     * This method returns the string of the icon file located in the icons director
     */
    public abstract String getIconImage();

    /**
     * This method returns the string of the image used to replace the mouse once a tool has been selected
     */
    public abstract String getCursorImage();

    /**
     * Returns the string name of the tool
     */
    public abstract String getString();
    
    /************************************************************************************
    ************************************************************************************
    ************************************************************************************
    **
    ** Everything else beyond this point are helpful interaction methods that can be used
    ** for any kind of tool
    **
    ************************************************************************************
    ************************************************************************************
    ************************************************************************************/

    /**
     * This method checks to see if the user double clicked with this took
     **/
    long t, lastt;
    int clickmx, clickmy;

    public boolean checkDoubleClick(int x, int y) {
        t = System.currentTimeMillis();
        long res = t-lastt;
        lastt = t;

        boolean isInSameSpot = ((Math.abs(clickmx - x) < 5) && (Math.abs(clickmy - y) < 5));
        clickmx = x;
        clickmy = y;

        return ((res<500) && (isInSameSpot));
    }
    
}
