//
//  THSPanel.java
//  Treehousestudio
//
//  Created by john maeda on Thu Aug 15 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

package treehouse;
import java.awt.*;
import java.applet.*;
import java.util.*;

/**
 * Essentially a THSPanel is just any kind of container placed on a Treehouse Studio Applet's work space.
 * good examples of how to use a THSPanel are the ColorPalette, the THSCanvas class, and the THSIconPanel.
 * There needs to be more documentation...
 */
public abstract class THSPanel
{
    protected int cx, cy, cw,ch;
    protected String cs;

    protected THSPanel target;
    protected THSPanel parent;
    protected Vector children;
    protected Hashtable childrenht;

    public THSPanel(String _s, int _x, int _y, int _w, int _h) {
        super();
        //this.setBounds(_x, _y, 1000, 1000);
        //this.setVisible(true);
        cx = _x;cy = _y; ch = _h; cw = _w; cs = _s;
        children = new Vector();
        childrenht = new Hashtable();
    }

    public THSPanel getTarget() {
        return target;
    }

    public String getCs() {
        return cs;
    }

    public int getCh() {
        return ch;
    }

    public int getCw() {
        return cw;
    }

    public int getCx() {
        return cx;
    }

    public int getCy() {
        return cy;
    }

    public void setTarget(THSPanel h) {
        target = h;
    }

    public void addChild(THSPanel h) {
        // this.add(h);
        children.addElement(h);
        childrenht.put(h.cs, h);
        h.setParent(this);
    }

    public void setParent(THSPanel h) {
        parent = h;
    }

    public boolean hasChildren() {
        if (children.size() > 0)
            return true;
        return false;
    }

    public void err(String s) {
        System.out.println("error: "+s);
    }

    public String getString() {
        return cs;
    }

    public void placeString(Graphics g) {
        g.drawString(cs,cx+(cw - g.getFontMetrics().stringWidth(cs))/2,cy+ch-g.getFontMetrics().getDescent());
    }

    public void placeBorder(Graphics g) {
        g.drawRect(cx,cy,cw,ch);
    }

    public void fill(Graphics g) {
        g.fillRect(cx,cy,cw,ch);
    }

    public boolean insidep(int mx, int my) {
        int s = 2;
        return (mx>cx-s&&mx<cx+cw+s&&my>cy-s&&my<cy+ch+s);
    }

    public void resize(Applet app, int cw, int ch) {
        if ((cw < 1) || (ch < 1) || (cw > app.getWidth()) || (ch > app.getHeight())) {
            return; // resize values are too big or too small
        }
        this.cw = cw;
        this.ch = ch;
    }


    /**
        * This method checks to see if the user double clicked on the canvas.  It should be used in the mouseDown method
     * of any THSPanel that is looking for a double click.
     */
    long t, lastt;
    int clickmx, clickmy;

    public boolean checkDoubleClick(int x, int y) {
        t = System.currentTimeMillis();
        long res = t-lastt;
        lastt = t;

        boolean isInSameSpot = ((Math.abs(clickmx - x) < 5) && (Math.abs(clickmy - y) < 5));
        clickmx = x;
        clickmy = y;

        return ((res<500) && (isInSameSpot));
    }
    
    /**
     * These are to make this type be a true super type
     */

    public abstract void message(String fromWho, Object odat);
    public abstract boolean mouseDown(Event ev, int x, int y);
    public abstract boolean mouseUp(Event ev, int x, int y);
    public abstract boolean mouseDrag(Event ev, int x, int y);
    public boolean mouseMove(Event ev, int mx, int my) { return true; }
    public abstract boolean keyDown(Event ev, int k);

    /**
     * This method should be overriden if a Panel wants to paint something.  In other words, this should be overriden
     */
    public void paint(Graphics g) {
        for (int i = 0; i < children.size(); i++) {
            THSPanel currPanel = (THSPanel) children.elementAt(i);
            currPanel.paint(g);
        }
    }
}
