//
//  THSWriteCanvas.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Thu Jan 23 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package treehouse;

import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.applet.*;

/**
 * This abstract treehouse class handles describing how to write the canvas to a byte array which can then be used to
 * perform a number of operations, including saving to the db.  Each applet should implement how it wants to break up
 * the graphics into bytes and translate bytes back into graphics, so the methods extractImage() and rasterizeImage()
 * are left for the programmer to implement.  There are some helpful methods added along here that can be used at the
 * programmers convenience.
 */
public abstract class THSWriteCanvas
{
    public int []graster=null;
    protected Image datim;

    public int w, h;

    public THSWriteCanvas(int _w, int _h) {
        w = _w; h = _h;
    }

    public THSWriteCanvas() {
    }

    public void setWidth(int w) {
        this.w = w;
    }

    public void setHeight(int h) {
        this.h = h;
    }

    public int getWidth() {
        return w;
    }

    public int getHeight() {
        return h;
    }
    
    public Image rasterImage(Applet app)
    {
        DirectColorModel dm;
        MemoryImageSource ms;
        int i,j,k;

        dm = new DirectColorModel(24,0xff0000,0xff00,0xff);

        ms = new MemoryImageSource(w,h,dm,graster,0,w);
        ms.setAnimated(false);
        datim = app.createImage(ms);
        return datim;
    }

    public abstract Image extractImage(byte[] b, Applet app);
    public abstract byte[] rasterizeImage(Image img);

}